#include "globals.h"
#include "sha.h"
//#include "salsa.h"
//#include "shittify.h"
#include "scrypt.h"

__attribute__((reqd_work_group_size(WORKSIZE, 1, 1)))
__kernel void search(volatile __global uint4 *restrict input,
volatile __global uint *restrict output,
#if (CLSIZE == 64)
__global uint16 *restrict padcache,
#else
__global uint8 *restrict padcache,
#endif
volatile uint4 midstate0, volatile uint4 midstate16, const uint target){


#if (CLSIZE == 64)
	//uint16 X[2];


#else
	uint8 X[4];
#endif

	uint in0 = input[4].s0;
	uint in1 = input[4].s1;
	uint in2 = input[4].s2;

#ifdef GOFFSET
	uint gid = get_global_id(0);
#else
	uint gid = input[4].s3 + get_global_id(0);
#endif

	uint8 ostate = {0x6a09e667U, 0xBB67AE85U, 0x3C6EF372U, 0xA54FF53AU, 0x510e527fU, 0x9b05688cU, 0x1F83D9ABU, 0x5BE0CD19U};
	uint8 tstate = ostate;
	uint8 tmpa = {in0, in1, in2, gid, SK00, zero, zero, zero};
	uint8 tmpb = {zero, zero, zero, zero, zero, zero, zero, SK01};
	uint8 tmpc = {midstate0.s0, midstate0.s1, midstate0.s2, midstate0.s3, midstate16.s0, midstate16.s1, midstate16.s2, midstate16.s3};
	uint tsb0, tsb1, tsb2, tsb3, tsb4, tsb5, tsb6, tsb7;
	uint lnum = 1;
	uint x = (gid%CONCURRENT_THREADS)<<1;
	SHA256(&tmpc, &tmpa, &tmpb);
	tmpb = tmpc^SK02;
	tmpa = SK02;
	SHA256(&ostate, &tmpb, &tmpa);
	tmpb = tmpc^SK03;
	tmpa = SK03;
	SHA256(&tstate, &tmpb, &tmpa);

	//backup tstate
	tsb0 = tstate.s0;
	tsb1 = tstate.s1;
	tsb2 = tstate.s2;
	tsb3 = tstate.s3;
	tsb4 = tstate.s4;
	tsb5 = tstate.s5;
	tsb6 = tstate.s6;
	tsb7 = tstate.s7;

	tmpb.lo = input[0];
	tmpb.hi = input[1];
	tmpc.lo = input[2];
	tmpc.hi = input[3];

	SHA256(&tstate, &tmpb, &tmpc);

	tmpb = zero;
#if (CLSIZE == 64)
	for(uint i=0; i<4; i++){
		//reset a
		tmpa.s0 = in0;
		tmpa.s1 = in1;
		tmpa.s2 = in2;
		tmpa.s3 = gid;
		tmpa.s4 = lnum++;
		tmpa.s5 = SK00;
		tmpa.s6 = zero;
		tmpa.s7 = zero;
		//set b
		tmpb.s0 = zero;
		tmpb.s7 = SK04;
		//set c
		tmpc = tstate;
		SHA256(&tmpc, &tmpa, &tmpb);
		//set a
		tmpa = ostate;
		//set b
		tmpb.s0 = SK00;
		tmpb.s7 = SK05;
		SHA256(&tmpa, &tmpc, &tmpb);

if(i&one)
padcache[((i>>1)+x)].hi = tmpa;
else
padcache[((i>>1)+x)].lo = tmpa;

//		if(i&one)
//			X[i>>1].hi = tmpa;
//		else
//			X[i>>1].lo = tmpa;
	}
#else
	for(uint i=0; i<4; i++){
		//reset a
		tmpa.s0 = in0;
		tmpa.s1 = in1;
		tmpa.s2 = in2;
		tmpa.s3 = gid;
		tmpa.s4 = lnum++;
		tmpa.s5 = SK00;
		tmpa.s6 = zero;
		tmpa.s7 = zero;
		//set b
		tmpb.s0 = zero;
		tmpb.s7 = SK04;
		//set c
		tmpc = tstate;
		SHA256(&tmpc, &tmpa, &tmpb);
		//set a
		tmpa = ostate;
		//set b
		tmpb.s0 = SK00;
		tmpb.s7 = SK05;
		SHA256(&tmpa, &tmpc, &tmpb);
		X[i] = tmpa;
	}
#endif

#if (CLSIZE == 64)
//	X[0] = EndianSwapa(X[0].s49e38d27c16b05af);
//	X[1] = EndianSwapa(X[1].s49e38d27c16b05af);

	scrypt_core(padcache);
//	scrypt_core(X, padcache);
//	X[0] = EndianSwapa(X[0].sc9630da741eb852f);
//	X[1] = EndianSwapa(X[1].sc9630da741eb852f);
#else
//	shittify(X);
	scrypt_core(X, padcache);
//	unshittify(X);
#endif

	tstate.s0 = tsb0;
	tstate.s1 = tsb1;
	tstate.s2 = tsb2;
	tstate.s3 = tsb3;
	tstate.s4 = tsb4;
	tstate.s5 = tsb5;
	tstate.s6 = tsb6;
	tstate.s7 = tsb7;

#if (CLSIZE == 64)
	for(uint i=0; i<2; i++){
		//tmpa = X[i].lo;
		//tmpc = X[i].hi;

		tmpa = padcache[x+i].lo;
		tmpc = padcache[x+i].hi;
		SHA256(&tstate, &tmpa, &tmpc);
	}
#else
	for(uint i=0; i<4; i+=2)
		SHA256(&tstate, X+i, X+i+1);
#endif

	tsb0 = tstate.s0;
	tsb1 = tstate.s1;
	tsb2 = tstate.s2;
	tsb3 = tstate.s3;
	tsb4 = tstate.s4;
	tsb5 = tstate.s5;
	tsb6 = tstate.s6;
	tsb7 = tstate.s7;

#define A tsb0
#define B tsb1
#define C tsb2
#define D tsb3
#define E tsb4
#define F tsb5
#define G tsb6
#define H tsb7
	for(uint i=0; i<8; i++){
		FXRD(A,B,C,D,E,F,G,H, fixedW[i].s0);
		FXRD(H,A,B,C,D,E,F,G, fixedW[i].s1);
		FXRD(G,H,A,B,C,D,E,F, fixedW[i].s2);
		FXRD(F,G,H,A,B,C,D,E, fixedW[i].s3);
		FXRD(E,F,G,H,A,B,C,D, fixedW[i].s4);
		FXRD(D,E,F,G,H,A,B,C, fixedW[i].s5);
		FXRD(C,D,E,F,G,H,A,B, fixedW[i].s6);
		FXRD(B,C,D,E,F,G,H,A, fixedW[i].s7);
	}
#undef A
#undef B
#undef C
#undef D
#undef E
#undef F
#undef G
#undef H

	tstate.s0 += tsb0;
	tstate.s1 += tsb1;
	tstate.s2 += tsb2;
	tstate.s3 += tsb3;
	tstate.s4 += tsb4;
	tstate.s5 += tsb5;
	tstate.s6 += tsb6;
	tstate.s7 += tsb7;

	SHA256(&ostate, &tstate, &tmpb);

	bool found = (EndianSwapa((ostate.s7)) <= target);
	if(found)
		SETFOUND(gid);
}